%global tar_version 4.1.3

Name: java-ovirt-engine-sdk4
Version: 4.1.3
Release: 0.1%{?dist}
Summary: Java SDK for version 4 of the oVirt Engine API
Group: Development/Languages
License: ASL 2.0
URL: http://ovirt.org/wiki/SDK

# This should be a tar file containing the generated source code of the
# SDK, as we can't build and run the generator with the packages
# available in the distribution:
Source0: ovirt-engine-sdk-java-%{tar_version}.tar.gz

# This file is used to perform the build using Ant, because the upstream
# project has build dependencies that make it impossible to build it
# with the packages available in the distribution:
Source1: build.xml

# This file is used to transform the upstream 'pom.xml' file into a
# 'pom-nodeps.xml' file that doesn't have the dependencies of the
# code generator, as those aren't available in the distribution:
Source2: transform-pom.xsl

BuildArch: noarch

BuildRequires: ant
BuildRequires: javapackages-local
BuildRequires: mvn(com.sun.xml.txw2:txw2)
BuildRequires: mvn(org.apache.httpcomponents:httpclient)
BuildRequires: mvn(org.apache.httpcomponents:httpcore)
BuildRequires: mvn(org.codehaus.jackson:jackson-core-asl)
BuildRequires: mvn(org.codehaus.jackson:jackson-mapper-asl)
BuildRequires: mvn(org.slf4j:slf4j-api)

%description
This package contains the Java SDK for version 4 of the oVirt Engine
API.

%prep

# Extract the source:
%setup -q -n ovirt-engine-sdk-java-%{tar_version}

%build

# Copy the files required for the Ant build to the extracted SDK
# directory:
cp %{SOURCE1} %{SOURCE2} .

# Populate the lib directory with symlinks to the required dependencies that
# will be used to create the compiler classpath:
mkdir lib
while read jar
do
  ln -s %{_javadir}/${jar}.jar lib
done << __EOF__
httpcomponents/httpclient
httpcomponents/httpcore
jackson/jackson-core-asl
jackson/jackson-mapper-asl
slf4j/api
txw2
__EOF__

# Perform build using Ant:
java -jar %{_javadir}/ant-launcher.jar -f build.xml

%install

# Install the POM without dependencies created during the build process
# and the .jar file:
%mvn_artifact pom-nodeps.xml target/%{name}.jar
%mvn_install

%files -f .mfiles
%dir %{_javadir}/%{name}
%doc README.adoc
%license LICENSE.txt

%changelog
* Tue Jan 31 2017 Ondra Machacek <omachace@redhat.com> - 4.1.0-1
- Update to model 4.1.29.
- Improved documentation.
- Add new lease attribute to virtual machines and templates.

* Fri Jan 13 2017 Ondra Machacek <omachace@redhat.com> - 4.1.0-0.1.alpha1
- Update to model 4.1.27 and metamodel 1.1.10.
- Fix reading of XML attributes of enum types #1408839.
- Enable compression by default #1370485.

* Tue Nov 15 2016 Ondra Machacek <omachace@redhat.com> - 4.0.3-1
- Update to model 4.0.37 and metamodel 1.0.21.
- Accept 202 code for 'Add' methods.
- Convert 'all_content' parameter to 'All-Content' header
- Add missing `template` and `storage_domain` parameters to the
  operation that imports an image.
- Add the `next_run` parameter to the operation that updates a virtual
  machine.
- Add the `all_content` parameters to the operations that list and
  retrieve virtual machines.

* Tue Sep 20 2016 Ondra Machacek <omachace@redhat.com> - 4.0.2-1
- Update to model 4.0.33 and metamodel 4.0.18
- Add the `custom_scheduling_policy_properties` attribute to the `Cluster` type
- Add services and types to support transfer of images
- Remove the `add` and `remove` operations of virtual machine CDROMs
- Use pooling http client
- Fix the type of the `usages` attribute of the `Network` type

* Mon Sep 05 2016 Ondra Machacek <omachace@redhat.com> - 4.0.1-1
- Update jackson dependencies versions to latest version
- Generate RPM Maven dependencies
- Avoid of reading fault response in case response body is empty
- Don't return null from send method in case of failure
- Fix tag names of action parameters

* Mon Aug 29 2016 Ondra Machacek <omachace@redhat.com> - 4.0.0-1
- Add missing required packages to spec files

* Mon Aug 22 2016 Ondra Machacek <omachace@redhat.com> - 4.0.0-0.15.alpha15
- Use POST method
- Name plular element tag same as the member
- Send query parameters with Add/Update actions
- Update to model 4.0.32 and metamodel 1.0.17
- Add option to not revoke token when closing connection
- Support both httpclient versions in built jar
- Add support to pass SSO token to SDK connection
- Support /v4 suffix in API URL

* Tue Jul 19 2016 Ondra Machacek <omachace@redhat.com> - 4.0.0-0.13.alpha13
- Update to model 4.0.28.
- Added `switch_type` attribute to `Host` type.
- Add `permits` to the cluster level type.
- Add the `current` parameter to the virtual machine graphics consoles service.
- Fix the name of the output parameter of the method to list affinity
  groups, should be `groups` instead of `list`.

* Thu Apr 7 2016 Juan Hernandez <juan.hernandez@redhat.com> - 4.0.0
- Initial packaging.
